# -*- coding: UTF-8 -*-

import time
def fsm_debug( s ):
    t = time.time()
    msec = (t - int(t))*1000000
    print '%s.%d %s' % ( time.strftime('%H:%M:%S', time.localtime(t)), msec, s )


class FrigeFSM(object):
    '''
    It's the same FSM, as in step2, but it is used from another automata,
    which describes operations on frige and two animals
    
    То же, что и автомат на 2 шаге, но он используется из другого автомата,
    который описывает действия с животными
    
    '''

    Open = 1
    Close = 2

    Closed = 1
    Opened = 2

    def __init__(self):
        super(FrigeFSM, self).__init__()
        self.__events     = []
        self.__Y       = FrigeFSM.Closed

        print "\nBegin FSM XML:FrigeFSM"
        print "<!DOCTYPE FSM> <FSM> <statemachine> <name>FrigeFSM</name> <comment>It's the same FSM, as in step2, but it is used from another automata, which describes operations on frige and two animals То же, что и автомат на 2 шаге, но он используется из другого автомата, который описывает действия с животными</comment> <initialstate>Closed</initialstate> <event> <name>Open</name> <comment>Открыть холодильник</comment> </event> <event> <name>Close</name> <comment>Закрыть холодильник</comment> </event> <output> <name>turnLightOff</name> <comment>Turn Light Off</comment> </output> <output> <name>turnLightOn</name> <comment>Turn Light On</comment> </output> <state> <name>Closed</name> <comment>Холодильник закрыт</comment> <incomeactions> <action type=\"output\" >turnLightOff</action> </incomeactions> <outcomeactions/> <transitions> <transition type=\"simple\" > <name>open</name> <comment>Нас кто-то открывает</comment> <condition>Open</condition> <destination>Opened</destination> <transite_destination/> <transitionactions/> </transition> </transitions> </state> <state> <name>Opened</name> <comment/> <incomeactions> <action type=\"output\" >turnLightOn</action> </incomeactions> <outcomeactions/> <transitions> <transition type=\"simple\" > <name>close</name> <comment>Нас закрывают</comment> <condition>Close</condition> <destination>Closed</destination> <transite_destination/> <transitionactions/> </transition> </transitions> </state> </statemachine> <graphics> <class classname=\"GStateSaver\" > <meta classname=\"GSaver\" > <data classname=\"GSaver\" /> </meta> <data classname=\"GStateSaver\" > <qstring name=\"stateName\" >Opened</qstring> <QPoint name=\"position\" > <int>5368</int> <int>5269</int> </QPoint> </data> </class> <class classname=\"GStateSaver\" > <meta classname=\"GSaver\" > <data classname=\"GSaver\" /> </meta> <data classname=\"GStateSaver\" > <qstring name=\"stateName\" >Closed</qstring> <QPoint name=\"position\" > <int>5101</int> <int>5267</int> </QPoint> </data> </class> <class classname=\"GTransitionSaver\" > <meta classname=\"GSaver\" > <data classname=\"GSaver\" /> </meta> <data classname=\"GTransitionSaver\" > <qstring name=\"stateName\" >Closed</qstring> <int name=\"transition\" >0</int> <qvaluelist name=\"points\" > <QPoint> <int>5269</int> <int>5236</int> </QPoint> </qvaluelist> </data> </class> <class classname=\"GTransitionSaver\" > <meta classname=\"GSaver\" > <data classname=\"GSaver\" /> </meta> <data classname=\"GTransitionSaver\" > <qstring name=\"stateName\" >Opened</qstring> <int name=\"transition\" >0</int> <qvaluelist name=\"points\" > <QPoint> <int>5268</int> <int>5330</int> </QPoint> </qvaluelist> </data> </class> </graphics> </FSM>"
        print "\nEnd FSM XML"


    def turnLightOff( self ):
        '''
        Turn Light Off
        
        '''

        print "turnLightOff is not implemented yet"
    def turnLightOn( self ):
        '''
        Turn Light On
        
        '''

        print "turnLightOn is not implemented yet"

    def __processEvent( self, e ):

        yOld = self.__Y
        fsm_debug( "FrigeFSM:%#x:event:%s:begin" % (hash(self), self.eventName(e)) )
        if self.__Y == FrigeFSM.Closed:
            if e == self.Open:# open
                fsm_debug( "FrigeFSM:%#x:state:Closed:leave:begin" % hash(self) )
                #outcome actions
                fsm_debug( "FrigeFSM:%#x:state:Closed:leave:end" % hash(self) )

                fsm_debug( "FrigeFSM:%#x:transition:0:begin" % hash(self) )
                # transition actions
                fsm_debug( "FrigeFSM:%#x:transition:0:end" % hash(self) )

                self.__Y = FrigeFSM.Opened
        elif self.__Y == FrigeFSM.Opened:
            if e == self.Close:# close
                fsm_debug( "FrigeFSM:%#x:state:Opened:leave:begin" % hash(self) )
                #outcome actions
                fsm_debug( "FrigeFSM:%#x:state:Opened:leave:end" % hash(self) )

                fsm_debug( "FrigeFSM:%#x:transition:0:begin" % hash(self) )
                # transition actions
                fsm_debug( "FrigeFSM:%#x:transition:0:end" % hash(self) )

                self.__Y = FrigeFSM.Closed

        if yOld != self.__Y:

            if self.__Y == FrigeFSM.Closed:
                fsm_debug( "FrigeFSM:%#x:state:Closed:enter:begin" % hash(self) )
                fsm_debug( "FrigeFSM:%#x:output:turnLightOff:begin" % hash(self) )
                self.turnLightOff()
                fsm_debug( "FrigeFSM:%#x:output:turnLightOff:end" % hash(self) )


                fsm_debug( "FrigeFSM:%#x:state:Closed:enter:end" % hash(self) )
            elif self.__Y == FrigeFSM.Opened:
                fsm_debug( "FrigeFSM:%#x:state:Opened:enter:begin" % hash(self) )
                fsm_debug( "FrigeFSM:%#x:output:turnLightOn:begin" % hash(self) )
                self.turnLightOn()
                fsm_debug( "FrigeFSM:%#x:output:turnLightOn:end" % hash(self) )


                fsm_debug( "FrigeFSM:%#x:state:Opened:enter:end" % hash(self) )

        fsm_debug( "FrigeFSM:%#x:event:%s:end" % ( hash(self), self.eventName(e) ) )


    def A( self, e ):
        '''
        Use this function to send event to FrigeFSM
        After you call it given event will be handled,
        and, if some of transition conditions match, 
        appropriate transition will be triggered,
        and currentState() will be changed. 

        If this function is called during existing event
        handling process, given event will be added to 
        pending event queue, and will be handled after current
        transition. See examples for details.
        '''
        if not self.__events:
            self.__events.append( e )
            while self.__events:
                self.__processEvent( self.__events[ 0 ] )
                self.__events.pop( 0 )
        else:
            self.__events.append( e )

    def __debug_iNtErNal_input( self, type, name, i):
        if i:
            fsm_debug( "FrigeFSM:%#x:input:%s:true" % (hash(self), name) )
        else:
            fsm_debug( "FrigeFSM:%#x:input:%s:false" % (hash(self), name) )
        return i

    def eventName( self, e ):
        '''
        Get symbolic name of an event
        '''
        if e == FrigeFSM.Open:
            return "Open"
        elif e == FrigeFSM.Close:
            return "Close"
        else:
            return "Unknown event"

    def stateName( self, s ):
        '''
        Get symbolic name of a state
        '''
    def currentState( self ):
        '''
        Get current state (as a number).
        Use stateName(self, s) to get a symbolic state name
        '''

        return self.__Y

        if s == FrigeFSM.Closed:
            return "Closed";
        elif s == FrigeFSM.Opened:
            return "Opened";
        else:
            return "Unknown state"

