import time
def fsm_debug( s ):
    t = time.time()
    msec = (t - int(t))*1000000
    print '%s.%d %s' % ( time.strftime('%H:%M:%S', time.localtime(t)), msec, s )


class FrigeLogicFSM(object):
    '''
    Here is a logic to solve a joke problem: 
    \"How to put a giraffe to the frige in 3 steps?\"
    \"Open the frige, put giraffe, close the frige\"
    \"And how to put a behemoth to the frige in 4 steps?\"
    \"Open the frige, get giraffe, put behemoth, close the frige\"
    
    And here is an \"extension\": you can free the frige by taking appropriate 
    animal out.
    
    '''

    PutHippopotamus = 1
    PutGiraffe = 2
    FreeFrige = 3

    Empty = 1
    Hippopotamus = 2
    Giraffe = 3

    def __init__(self):
        super(FrigeLogicFSM, self).__init__()
        self.__events     = []
        self.__Y       = FrigeLogicFSM.Empty

        print "\nBegin FSM XML:FrigeLogicFSM"
        print "<!DOCTYPE FSM> <FSM> <statemachine> <name>FrigeLogicFSM</name> <comment>Here is a logic to solve a joke problem: &quot;How to put a giraffe to the frige in 3 steps?&quot; &quot;Open the frige, put giraffe, close the frige&quot; &quot;And how to put a behemoth to the frige in 4 steps?&quot; &quot;Open the frige, get giraffe, put behemoth, close the frige&quot; And here is an &quot;extension&quot;: you can free the frige by taking appropriate animal out. </comment> <initialstate>Empty</initialstate> <event> <name>PutHippopotamus</name> <comment/> </event> <event> <name>PutGiraffe</name> <comment/> </event> <event> <name>FreeFrige</name> <comment/> </event> <output> <name>getHippopotamus</name> <comment/> </output> <output> <name>getGiraffe</name> <comment/> </output> <output> <name>putGiraffe</name> <comment/> </output> <output> <name>putHippopotamus</name> <comment/> </output> <output> <name>openFrige</name> <comment/> </output> <output> <name>closeFrige</name> <comment/> </output> <state> <name>Empty</name> <comment>There's noone in a frige</comment> <incomeactions/> <outcomeactions/> <transitions> <transition type=\"simple\" > <name>giraffe</name> <comment>Put Giraffe to the frige</comment> <condition>PutGiraffe</condition> <destination>Giraffe</destination> <transite_destination/> <transitionactions> <action type=\"output\" >openFrige</action> <action type=\"output\" >putGiraffe</action> <action type=\"output\" >closeFrige</action> </transitionactions> </transition> <transition type=\"simple\" > <name>behemoth</name> <comment/> <condition>PutHippopotamus</condition> <destination>Hippopotamus</destination> <transite_destination/> <transitionactions> <action type=\"output\" >openFrige</action> <action type=\"output\" >putHippopotamus</action> <action type=\"output\" >closeFrige</action> </transitionactions> </transition> </transitions> </state> <state> <name>Hippopotamus</name> <comment>We put a hippopotamus to the frige</comment> <incomeactions/> <outcomeactions/> <transitions> <transition type=\"simple\" > <name>giraffe</name> <comment/> <condition>PutGiraffe</condition> <destination>Giraffe</destination> <transite_destination/> <transitionactions> <action type=\"output\" >openFrige</action> <action type=\"output\" >getHippopotamus</action> <action type=\"output\" >putGiraffe</action> <action type=\"output\" >closeFrige</action> </transitionactions> </transition> <transition type=\"simple\" > <name>free</name> <comment/> <condition>FreeFrige</condition> <destination>Empty</destination> <transite_destination/> <transitionactions> <action type=\"output\" >openFrige</action> <action type=\"output\" >getHippopotamus</action> <action type=\"output\" >closeFrige</action> </transitionactions> </transition> </transitions> </state> <state> <name>Giraffe</name> <comment>We put a giraffe to the frige</comment> <incomeactions/> <outcomeactions/> <transitions> <transition type=\"simple\" > <name>hippo</name> <comment/> <condition>PutHippopotamus</condition> <destination>Hippopotamus</destination> <transite_destination/> <transitionactions> <action type=\"output\" >openFrige</action> <action type=\"output\" >getGiraffe</action> <action type=\"output\" >putHippopotamus</action> <action type=\"output\" >closeFrige</action> </transitionactions> </transition> <transition type=\"simple\" > <name>free</name> <comment/> <condition>FreeFrige</condition> <destination>Empty</destination> <transite_destination/> <transitionactions> <action type=\"output\" >openFrige</action> <action type=\"output\" >getGiraffe</action> <action type=\"output\" >closeFrige</action> </transitionactions> </transition> </transitions> </state> </statemachine> <graphics> <class classname=\"GStateSaver\" > <meta classname=\"GSaver\" > <data classname=\"GSaver\" /> </meta> <data classname=\"GStateSaver\" > <qstring name=\"stateName\" >Giraffe</qstring> <QPoint name=\"position\" > <int>5197</int> <int>5303</int> </QPoint> </data> </class> <class classname=\"GStateSaver\" > <meta classname=\"GSaver\" > <data classname=\"GSaver\" /> </meta> <data classname=\"GStateSaver\" > <qstring name=\"stateName\" >Empty</qstring> <QPoint name=\"position\" > <int>5343</int> <int>5086</int> </QPoint> </data> </class> <class classname=\"GStateSaver\" > <meta classname=\"GSaver\" > <data classname=\"GSaver\" /> </meta> <data classname=\"GStateSaver\" > <qstring name=\"stateName\" >Hippopotamus</qstring> <QPoint name=\"position\" > <int>5450</int> <int>5310</int> </QPoint> </data> </class> <class classname=\"GTransitionSaver\" > <meta classname=\"GSaver\" > <data classname=\"GSaver\" /> </meta> <data classname=\"GTransitionSaver\" > <qstring name=\"stateName\" >Empty</qstring> <int name=\"transition\" >0</int> <qvaluelist name=\"points\" > <QPoint> <int>5273</int> <int>5195</int> </QPoint> </qvaluelist> </data> </class> <class classname=\"GTransitionSaver\" > <meta classname=\"GSaver\" > <data classname=\"GSaver\" /> </meta> <data classname=\"GTransitionSaver\" > <qstring name=\"stateName\" >Empty</qstring> <int name=\"transition\" >1</int> <qvaluelist name=\"points\" > <QPoint> <int>5456</int> <int>5204</int> </QPoint> </qvaluelist> </data> </class> <class classname=\"GTransitionSaver\" > <meta classname=\"GSaver\" > <data classname=\"GSaver\" /> </meta> <data classname=\"GTransitionSaver\" > <qstring name=\"stateName\" >Giraffe</qstring> <int name=\"transition\" >0</int> <qvaluelist name=\"points\" > <QPoint> <int>5363</int> <int>5286</int> </QPoint> </qvaluelist> </data> </class> <class classname=\"GTransitionSaver\" > <meta classname=\"GSaver\" > <data classname=\"GSaver\" /> </meta> <data classname=\"GTransitionSaver\" > <qstring name=\"stateName\" >Giraffe</qstring> <int name=\"transition\" >1</int> <qvaluelist name=\"points\" > <QPoint> <int>5322</int> <int>5224</int> </QPoint> </qvaluelist> </data> </class> <class classname=\"GTransitionSaver\" > <meta classname=\"GSaver\" > <data classname=\"GSaver\" /> </meta> <data classname=\"GTransitionSaver\" > <qstring name=\"stateName\" >Hippopotamus</qstring> <int name=\"transition\" >0</int> <qvaluelist name=\"points\" > <QPoint> <int>5364</int> <int>5367</int> </QPoint> </qvaluelist> </data> </class> <class classname=\"GTransitionSaver\" > <meta classname=\"GSaver\" > <data classname=\"GSaver\" /> </meta> <data classname=\"GTransitionSaver\" > <qstring name=\"stateName\" >Hippopotamus</qstring> <int name=\"transition\" >1</int> <qvaluelist name=\"points\" > <QPoint> <int>5395</int> <int>5220</int> </QPoint> </qvaluelist> </data> </class> </graphics> </FSM>"
        print "\nEnd FSM XML"


    def getHippopotamus( self ):
        print "getHippopotamus is not implemented yet"
    def getGiraffe( self ):
        print "getGiraffe is not implemented yet"
    def putGiraffe( self ):
        print "putGiraffe is not implemented yet"
    def putHippopotamus( self ):
        print "putHippopotamus is not implemented yet"
    def openFrige( self ):
        print "openFrige is not implemented yet"
    def closeFrige( self ):
        print "closeFrige is not implemented yet"

    def __processEvent( self, e ):

        yOld = self.__Y
        fsm_debug( "FrigeLogicFSM:%#x:event:%s:begin" % (hash(self), self.eventName(e)) )
        if self.__Y == FrigeLogicFSM.Empty:
            if e == self.PutGiraffe:# giraffe
                fsm_debug( "FrigeLogicFSM:%#x:state:Empty:leave:begin" % hash(self) )
                #outcome actions
                fsm_debug( "FrigeLogicFSM:%#x:state:Empty:leave:end" % hash(self) )

                fsm_debug( "FrigeLogicFSM:%#x:transition:0:begin" % hash(self) )
                # transition actions
                fsm_debug( "FrigeLogicFSM:%#x:output:openFrige:begin" % hash(self) )
                self.openFrige()
                fsm_debug( "FrigeLogicFSM:%#x:output:openFrige:end" % hash(self) )


                fsm_debug( "FrigeLogicFSM:%#x:output:putGiraffe:begin" % hash(self) )
                self.putGiraffe()
                fsm_debug( "FrigeLogicFSM:%#x:output:putGiraffe:end" % hash(self) )


                fsm_debug( "FrigeLogicFSM:%#x:output:closeFrige:begin" % hash(self) )
                self.closeFrige()
                fsm_debug( "FrigeLogicFSM:%#x:output:closeFrige:end" % hash(self) )


                fsm_debug( "FrigeLogicFSM:%#x:transition:0:end" % hash(self) )

                self.__Y = FrigeLogicFSM.Giraffe
            elif e == self.PutHippopotamus:# behemoth
                fsm_debug( "FrigeLogicFSM:%#x:state:Empty:leave:begin" % hash(self) )
                #outcome actions
                fsm_debug( "FrigeLogicFSM:%#x:state:Empty:leave:end" % hash(self) )

                fsm_debug( "FrigeLogicFSM:%#x:transition:1:begin" % hash(self) )
                # transition actions
                fsm_debug( "FrigeLogicFSM:%#x:output:openFrige:begin" % hash(self) )
                self.openFrige()
                fsm_debug( "FrigeLogicFSM:%#x:output:openFrige:end" % hash(self) )


                fsm_debug( "FrigeLogicFSM:%#x:output:putHippopotamus:begin" % hash(self) )
                self.putHippopotamus()
                fsm_debug( "FrigeLogicFSM:%#x:output:putHippopotamus:end" % hash(self) )


                fsm_debug( "FrigeLogicFSM:%#x:output:closeFrige:begin" % hash(self) )
                self.closeFrige()
                fsm_debug( "FrigeLogicFSM:%#x:output:closeFrige:end" % hash(self) )


                fsm_debug( "FrigeLogicFSM:%#x:transition:1:end" % hash(self) )

                self.__Y = FrigeLogicFSM.Hippopotamus
        elif self.__Y == FrigeLogicFSM.Hippopotamus:
            if e == self.PutGiraffe:# giraffe
                fsm_debug( "FrigeLogicFSM:%#x:state:Hippopotamus:leave:begin" % hash(self) )
                #outcome actions
                fsm_debug( "FrigeLogicFSM:%#x:state:Hippopotamus:leave:end" % hash(self) )

                fsm_debug( "FrigeLogicFSM:%#x:transition:0:begin" % hash(self) )
                # transition actions
                fsm_debug( "FrigeLogicFSM:%#x:output:openFrige:begin" % hash(self) )
                self.openFrige()
                fsm_debug( "FrigeLogicFSM:%#x:output:openFrige:end" % hash(self) )


                fsm_debug( "FrigeLogicFSM:%#x:output:getHippopotamus:begin" % hash(self) )
                self.getHippopotamus()
                fsm_debug( "FrigeLogicFSM:%#x:output:getHippopotamus:end" % hash(self) )


                fsm_debug( "FrigeLogicFSM:%#x:output:putGiraffe:begin" % hash(self) )
                self.putGiraffe()
                fsm_debug( "FrigeLogicFSM:%#x:output:putGiraffe:end" % hash(self) )


                fsm_debug( "FrigeLogicFSM:%#x:output:closeFrige:begin" % hash(self) )
                self.closeFrige()
                fsm_debug( "FrigeLogicFSM:%#x:output:closeFrige:end" % hash(self) )


                fsm_debug( "FrigeLogicFSM:%#x:transition:0:end" % hash(self) )

                self.__Y = FrigeLogicFSM.Giraffe
            elif e == self.FreeFrige:# free
                fsm_debug( "FrigeLogicFSM:%#x:state:Hippopotamus:leave:begin" % hash(self) )
                #outcome actions
                fsm_debug( "FrigeLogicFSM:%#x:state:Hippopotamus:leave:end" % hash(self) )

                fsm_debug( "FrigeLogicFSM:%#x:transition:1:begin" % hash(self) )
                # transition actions
                fsm_debug( "FrigeLogicFSM:%#x:output:openFrige:begin" % hash(self) )
                self.openFrige()
                fsm_debug( "FrigeLogicFSM:%#x:output:openFrige:end" % hash(self) )


                fsm_debug( "FrigeLogicFSM:%#x:output:getHippopotamus:begin" % hash(self) )
                self.getHippopotamus()
                fsm_debug( "FrigeLogicFSM:%#x:output:getHippopotamus:end" % hash(self) )


                fsm_debug( "FrigeLogicFSM:%#x:output:closeFrige:begin" % hash(self) )
                self.closeFrige()
                fsm_debug( "FrigeLogicFSM:%#x:output:closeFrige:end" % hash(self) )


                fsm_debug( "FrigeLogicFSM:%#x:transition:1:end" % hash(self) )

                self.__Y = FrigeLogicFSM.Empty
        elif self.__Y == FrigeLogicFSM.Giraffe:
            if e == self.PutHippopotamus:# hippo
                fsm_debug( "FrigeLogicFSM:%#x:state:Giraffe:leave:begin" % hash(self) )
                #outcome actions
                fsm_debug( "FrigeLogicFSM:%#x:state:Giraffe:leave:end" % hash(self) )

                fsm_debug( "FrigeLogicFSM:%#x:transition:0:begin" % hash(self) )
                # transition actions
                fsm_debug( "FrigeLogicFSM:%#x:output:openFrige:begin" % hash(self) )
                self.openFrige()
                fsm_debug( "FrigeLogicFSM:%#x:output:openFrige:end" % hash(self) )


                fsm_debug( "FrigeLogicFSM:%#x:output:getGiraffe:begin" % hash(self) )
                self.getGiraffe()
                fsm_debug( "FrigeLogicFSM:%#x:output:getGiraffe:end" % hash(self) )


                fsm_debug( "FrigeLogicFSM:%#x:output:putHippopotamus:begin" % hash(self) )
                self.putHippopotamus()
                fsm_debug( "FrigeLogicFSM:%#x:output:putHippopotamus:end" % hash(self) )


                fsm_debug( "FrigeLogicFSM:%#x:output:closeFrige:begin" % hash(self) )
                self.closeFrige()
                fsm_debug( "FrigeLogicFSM:%#x:output:closeFrige:end" % hash(self) )


                fsm_debug( "FrigeLogicFSM:%#x:transition:0:end" % hash(self) )

                self.__Y = FrigeLogicFSM.Hippopotamus
            elif e == self.FreeFrige:# free
                fsm_debug( "FrigeLogicFSM:%#x:state:Giraffe:leave:begin" % hash(self) )
                #outcome actions
                fsm_debug( "FrigeLogicFSM:%#x:state:Giraffe:leave:end" % hash(self) )

                fsm_debug( "FrigeLogicFSM:%#x:transition:1:begin" % hash(self) )
                # transition actions
                fsm_debug( "FrigeLogicFSM:%#x:output:openFrige:begin" % hash(self) )
                self.openFrige()
                fsm_debug( "FrigeLogicFSM:%#x:output:openFrige:end" % hash(self) )


                fsm_debug( "FrigeLogicFSM:%#x:output:getGiraffe:begin" % hash(self) )
                self.getGiraffe()
                fsm_debug( "FrigeLogicFSM:%#x:output:getGiraffe:end" % hash(self) )


                fsm_debug( "FrigeLogicFSM:%#x:output:closeFrige:begin" % hash(self) )
                self.closeFrige()
                fsm_debug( "FrigeLogicFSM:%#x:output:closeFrige:end" % hash(self) )


                fsm_debug( "FrigeLogicFSM:%#x:transition:1:end" % hash(self) )

                self.__Y = FrigeLogicFSM.Empty

        if yOld != self.__Y:

            if self.__Y == FrigeLogicFSM.Empty:
                fsm_debug( "FrigeLogicFSM:%#x:state:Empty:enter:begin" % hash(self) )
                pass
                fsm_debug( "FrigeLogicFSM:%#x:state:Empty:enter:end" % hash(self) )
            elif self.__Y == FrigeLogicFSM.Hippopotamus:
                fsm_debug( "FrigeLogicFSM:%#x:state:Hippopotamus:enter:begin" % hash(self) )
                pass
                fsm_debug( "FrigeLogicFSM:%#x:state:Hippopotamus:enter:end" % hash(self) )
            elif self.__Y == FrigeLogicFSM.Giraffe:
                fsm_debug( "FrigeLogicFSM:%#x:state:Giraffe:enter:begin" % hash(self) )
                pass
                fsm_debug( "FrigeLogicFSM:%#x:state:Giraffe:enter:end" % hash(self) )

        fsm_debug( "FrigeLogicFSM:%#x:event:%s:end" % ( hash(self), self.eventName(e) ) )


    def A( self, e ):
        '''
        Use this function to send event to FrigeLogicFSM
        After you call it given event will be handled,
        and, if some of transition conditions match, 
        appropriate transition will be triggered,
        and currentState() will be changed. 

        If this function is called during existing event
        handling process, given event will be added to 
        pending event queue, and will be handled after current
        transition. See examples for details.
        '''
        if not self.__events:
            self.__events.append( e )
            while self.__events:
                self.__processEvent( self.__events[ 0 ] )
                self.__events.pop( 0 )
        else:
            self.__events.append( e )

    def __debug_iNtErNal_input( self, type, name, i):
        if i:
            fsm_debug( "FrigeLogicFSM:%#x:input:%s:true" % (hash(self), name) )
        else:
            fsm_debug( "FrigeLogicFSM:%#x:input:%s:false" % (hash(self), name) )
        return i

    def eventName( self, e ):
        '''
        Get symbolic name of an event
        '''
        if e == FrigeLogicFSM.PutHippopotamus:
            return "PutHippopotamus"
        elif e == FrigeLogicFSM.PutGiraffe:
            return "PutGiraffe"
        elif e == FrigeLogicFSM.FreeFrige:
            return "FreeFrige"
        else:
            return "Unknown event"

    def stateName( self, s ):
        '''
        Get symbolic name of a state
        '''
    def currentState( self ):
        '''
        Get current state (as a number).
        Use stateName(self, s) to get a symbolic state name
        '''

        return self.__Y

        if s == FrigeLogicFSM.Empty:
            return "Empty";
        elif s == FrigeLogicFSM.Hippopotamus:
            return "Hippopotamus";
        elif s == FrigeLogicFSM.Giraffe:
            return "Giraffe";
        else:
            return "Unknown state"

