#!/usr/bin/env python

from frige import *
from frige_logic import *

class LightFrige( FrigeFSM ):
    def turnLightOn(self):
        print "Turning on the light"
    def turnLightOff(self):
        print "Turning off the light"

class FrigeLogic( FrigeLogicFSM ):
    def __init__(self, frige):
        super(FrigeLogic, self).__init__()
        self.frige = frige
        
    def putHippopotamus( self ):
        print "Putting Hippopotamus to the frige"

    def getGiraffe( self ):
        print "Getting Giraffe from the frige"

    def putGiraffe( self ):
        print "Putting Giraffe to the frige"

    def openFrige( self ):
        print "Opening frige"
        self.frige.A( FrigeFSM.Open )
        print "Frige opened"

    def closeFrige( self ):
        print "Closing frige"
        self.frige.A( FrigeFSM.Close )
        print "Frige closed"

    def getHippopotamus( self ):
        print "Getting Hippopotamus from the frige"

if __name__=="__main__":
    f = LightFrige()
    l = FrigeLogic( f )
    print "\n*** Putting Giraffe to Frige"
    l.A( FrigeLogicFSM.PutGiraffe )
    print "\n*** Putting Hippopotamus to Frige"
    l.A( FrigeLogicFSM.PutHippopotamus )
    print "\n*** Freeing Frige"
    l.A( FrigeLogicFSM.FreeFrige )
